#pragma once

#include <optional>

// złe opcjonalne parametry funkcji
void calculate_v1(int param) {}  // Jeśli param ma wartość -1, oznacza to "brak wartości".
void calculate_v2(int param = -1) {}

// dobre opcjonalne parametry funkcji
void calculate_v3(std::optional<int> param) {}

// złe opcjonalne wartości zwracane
int try_parse_v1(std::string_view maybe_number) { return {}; }
bool try_parse_v2(std::string_view maybe_number, int &parsed_number) {
  return {};
}
int *try_parse_v3(std::string_view maybe_number) { return {}; }

// dobra opcjonalna wartość zwracana
std::optional<int> try_parse_v4(std::string_view maybe_number) { return {}; }

using PhoneNumber = long long;

// dobre opcjonalne pola
struct UserProfile {
  std::string nickname;
  std::optional<std::string> full_name;
  std::optional<std::string> address;
  std::optional<PhoneNumber> phone;
};
